=== debian/changelog ===
actor-framework (0.17.6-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1112690)

 -- Adrian Bunk <bunk@debian.org>  Fri, 31 Oct 2025 22:29:12 +0200

actor-framework (0.17.6-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061864

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 00:04:41 +0000

actor-framework (0.17.6-3) unstable; urgency=medium

  * Add patch for missing include needed with GCC 13 (Closes: #1037568)

 -- Hilko Bengen <bengen@debian.org>  Fri, 28 Jul 2023 21:25:33 +0200

actor-framework (0.17.6-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Enable building with recent gcc. Thanks to Lukas Märdian for the patch.
    Closes: #983959

 -- Sascha Steinbiss <satta@debian.org>  Thu, 04 Nov 2021 12:45:28 +0100

actor-framework (0.17.6-2) unstable; urgency=medium

  * Source-only re-upload 

 -- Hilko Bengen <bengen@debian.org>  Thu, 10 Sep 2020 16:28:12 +0200

actor-framework (0.17.6-1) unstable; urgency=medium

  * New upstream version 0.17.6
  * Add patch from upstream PR #1135
  * Add patch to CMakeLists.txt to enable -std=c++14, avoid FTBFS

 -- Hilko Bengen <bengen@debian.org>  Thu, 10 Sep 2020 01:36:18 +0200

actor-framework (0.17.5-1) experimental; urgency=medium

  * Adopt package
  * New upstream version 0.17.5
  * Rename packages following new major upstream version
  * Fix SONAME, Python3 usage
  * Don't install PDF and RST versions of manual

 -- Hilko Bengen <bengen@debian.org>  Sat, 30 May 2020 16:09:53 +0200
